package io.trygvis.android.bt;

import android.bluetooth.BluetoothGatt;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattDescriptor;

import static io.trygvis.android.bt.BtPromise.PromiseResult;

public class BtCallback {
    public final boolean stopOnFailure;
    public final String name;

    public BtCallback(boolean stopOnFailure, String name) {
        this.stopOnFailure = stopOnFailure;
        this.name = name;
    }

    public PromiseResult onConnectionStateChange(BluetoothGatt gatt, int status, int newState) {
        throw new NotOverriddenException();
    }

    public PromiseResult onServicesDiscovered(BluetoothGatt gatt) {
        throw new NotOverriddenException();
    }

    public PromiseResult onCharacteristicRead(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic) {
        throw new NotOverriddenException();
    }

    public PromiseResult onCharacteristicWrite(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic) {
        throw new NotOverriddenException();
    }

    public PromiseResult onCharacteristicChanged(BluetoothGatt gatt, BluetoothGattCharacteristic characteristic) {
        throw new NotOverriddenException();
    }

    public PromiseResult onDescriptorRead(BluetoothGatt gatt, BluetoothGattDescriptor descriptor) {
        throw new NotOverriddenException();
    }

    public PromiseResult onDescriptorWrite(BluetoothGatt gatt, BluetoothGattDescriptor descriptor) {
        throw new NotOverriddenException();
    }

    public PromiseResult onReliableWriteCompleted(BluetoothGatt gatt) {
        throw new NotOverriddenException();
    }

    public PromiseResult onReadRemoteRssi(BluetoothGatt gatt, int rssi) {
        throw new NotOverriddenException();
    }

    public PromiseResult onDirect(BluetoothGatt value) {
        throw new NotOverriddenException();
    }

    public void onFailure() {
        throw new NotOverriddenException();
    }

    public void onFinally() {
        throw new NotOverriddenException();
    }

    @Override
    public String toString() {
        return "BtCallback{" +
                "name='" + name + '\'' +
                ", stopOnFailure=" + stopOnFailure +
                '}';
    }
}
